// $Id: test-ticket-client.C,v 1.2 2003/08/06 12:12:06 dvermeir Exp $

#include "ticket.h"

int
main(int argc,char* argv[]) {

try {
  std::cout << "1) Buy new ticket" << std::endl;
  Dv::Ticket::Ticket::Ref t1(
    Dv::Ticket::Ticket::buy("localhost", 1050, "dvermeir", "abcdef1", "INFO") );
  if (! t1)
    throw std::runtime_error("cannot buy ticket");

  std::cout << t1->xml() << std::endl;

  std::cout << "2) Validate the ticket" << std::endl;
  Dv::Ticket::Ticket::Ref t2(
    Dv::Ticket::Ticket::validate("localhost", 1050, t1->serial()) );
  if (! t2)
    throw std::runtime_error("cannot validate ticket");
  std::cout << t2->xml() << std::endl;

  std::cout << "3) Try to validate invalid serial #" << std::endl;
  Dv::Ticket::Ticket::Ref t3(
    Dv::Ticket::Ticket::validate("localhost", 1050, 10000) );
  if (t3)
    throw std::runtime_error("validate invalid serial succeeded!");
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
return 0;
}
