/// $Id: user.C,v 1.5 2003/08/06 12:12:06 dvermeir Exp $
#include "user.h"
#include <dvutil/tostring.h>
#include <dvxml/xml.h>

bool
Dv::Ticket::User::operator<(const Dv::Ticket::User& user) const { 
if (category() < user.category())
  return true;
else if (category() == user.category())
  return id() < user.id();
else
  return false;
}

Dv::Xml::Node
Dv::Ticket::User::xml(const std::string& node_name) const {
Dv::Xml::Node node(node_name);
(node >> "id") = Dv::Util::tostring(id());
(node >> "category") = category();
(node >> "name") = name();
(node >> "info") = info();
return node;
}

Dv::Ticket::User::User(Dv::Xml::Node::Ref xml_user) throw (Dv::Ticket::Exception) {
try {
  id_ = xml_user/"id";
  category_ = (xml_user/"category").str();
  name_ = (xml_user/"name").str();
  info_ = (xml_user/"info").str();
  }
catch (std::exception& e) {
  throw Dv::Ticket::Exception(e.what());
  }
}

