// $Id: xml-sndrcv.C,v 1.2 2003/08/08 09:51:00 dvermeir Exp $
#include <dvnet/message.h>
#include "xml-sndrcv.h"

void
Dv::Xml::receive(Dv::Xml::Document& document, std::istream& is) 
  throw (Dv::Xml::Exception) {
Dv::Net::SimpleMessage message;
try {
  message.receive(is);
  document.parse( message.data(), message.size() );
  }
catch (Dv::Xml::Exception& e) {
  throw;
  }
catch (std::exception& e) {
  throw Dv::Xml::Exception(e.what());
  }
}

void
Dv::Xml::send(const Dv::Xml::Document& document, std::ostream& os) 
  throw (Dv::Xml::Exception) {
static const std::string SEND_ERROR("error sending document with root name ");
std::string data;
try {
  document.save_to_string(data);
  Dv::Net::SimpleMessage message(data.data(), data.size() );
  if (! message.send(os) )
    throw Dv::Xml::Exception( SEND_ERROR + document.root().name() );
  }
catch (Dv::Xml::Exception& e) {
  throw;
  }
catch (std::exception& e) {
  throw Dv::Xml::Exception(e.what());
  }
}

