#ifndef DVLOGIN_XML_SNDRCV_H
#define DVLOGIN_XML_SNDRCV_H

// $Id: xml-sndrcv.h,v 1.3 2003/08/08 09:51:00 dvermeir Exp $
#include <string>
#include <iostream>
#include <stdexcept>
#include <dvxml/xml.h>

namespace Dv {
namespace Xml {

/** Receive an XML document from a stream (usually a socket)
 * @param document received.
 * @param is stream to receive document from.
 * @exception Dv::Xml::Exception if anything goes wrong.
 */
void receive(Dv::Xml::Document& document, std::istream& is) throw (Dv::Xml::Exception);

/** Send an XML document over a stream (usually a socket)
 * @param document to send.
 * @param os stream to send document to.
 * @exception Dv::Xml::Exception if anything goes wrong.
 */
void send(const Dv::Xml::Document& document, std::ostream& os) throw (Dv::Xml::Exception);

}}
#endif
