// $Id: test-cgi.C,v 1.1 2003/07/22 18:23:47 dvermeir Exp $

#include <fstream>
#include <sstream>
#include <dvticket/cgi.h>

bool
show_file(Dv::Cgi::Cgi& cgi, const Dv::Util::Props& out,
		const std::string& fn) {
std::ifstream ifs(fn.c_str());
if (ifs) {
  std::ostringstream oss;
  out.substitute(ifs, oss);
  cgi << oss.str() << std::endl;
  }
else {
  cgi->content_type("text/plain");
  cgi << fn << ": could not open\n\n" << out << std::endl;
  }
}

int
main(int argc,char* argv[]) {
Dv::Ticket::Cgi cgi("test.cgi", "tinf2.vub.ac.be/~dvermeir/login.cgi", "en", true);
try {
  Dv::Util::Props out;
  out.add("username", cgi.user().name());
  out.add("category", cgi.user().category());
  out.add("info", cgi.user().info());
  out.add("uid", Dv::Util::tostring(cgi.user().id()));
  out.add("here", cgi.here() );

  if (! cgi.props().find("age")) // first time
    show_file(cgi, out, "test-cgi2.html");
  else {
    try {
      // form has been filled
      int age = cgi.props()["age"];
      out["age"] = ++age;
      // out.add("age", cgi.props()["age"]);
      out.add("nickname", cgi.props()["nickname"]);
      show_file(cgi, out, "test-cgi2a.html");
      }
    catch (std::exception& e) {
      cgi->location(cgi.here());
      cgi << std::endl;
      }
    }
  }
catch (std::exception& e) {
  cgi->content_type("text/plain");
  cgi << e.what() << std::endl;
  return 1;
  }
return 0;
}
